Subject: Re: [RFC] bridge: prevent hairpin and STP problems?

From: Stephen Hemminger <[email-masked]>
Date: Mon, 17 Aug 2009 15:37:25 -0700

On Mon, 17 Aug 2009 21:16:04 +0000
"Fischer, Anna" <[email-masked]> wrote:

> > Subject: [RFC] bridge: prevent hairpin and STP problems?
> > 
> > Do we need to add this to block Spanning Tree from being enabled
> > with hairpin mode? I am not sure what the exact usage of hairpin
> > mode and if it is possible to create loops and get STP confusion.
> > 
> > For comment only, do not apply as is.
> 
> Your patch disables STP on the whole bridge if one or more ports
> are set to hairpin mode.
> 
> However, I don't really see that this is necessary. 
> 
> A hairpin mode port should not reflect BPDUs, because otherwise the
> connected port would think it has detected a loop. The hairpin mode
> port should still be able to generate BPDUs though, and in any case
> the bridge should still be able to run STP.
> 
> The hairpin patch we submitted reflects packets on the forwarding /
> data path whereas BPDUs are processed with a separate hook, so we
> should not be reflecting BPDUs back out of a hairpin mode port.

So if user is using hairpin properly, the STP would work. In fact
it would be a good thing since it would detect looping configurations.